/*
 * File         : SAP.h
 * Author       : Pawel Roman
 * Created      : Tue Aug 26 14:40:10 1997
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#if !defined( __SAP_H )
#define __SAP_H

#if defined( _WIN32 )
#include <winsock2.h>
#else
#include <stdio.h>
#include <unistd.h>
#endif

class SAP
{
public:
	typedef int SAP_HANDLE;

	int open( int port, const char* host );
	int open( int port );
	int open( struct sockaddr_in *addr );
	int close() { return ::close( handle_ ); }
	int recv_n( void* buffer, size_t len ) const;
    int recv_n( void* buffer, size_t len, int flags, timeval* tv ) const;
    int send_n( void* buffer, size_t len ) const;
    SAP_HANDLE get_handle( void ) const { return handle_; }
    void set_handle( SAP_HANDLE h ) { handle_ = h; }
      
protected:
      SAP_HANDLE handle_;
};

#endif

